name = "Extra Equip Slots"
description = "Add One/Two Slots: Backpack and Amulet"
author = "zzzzzzzs"
version = "20230512"
forumthread = ""
api_version = 6
priority = 0
dont_starve_compatible = true
reign_of_giants_compatible = true
shipwrecked_compatible = true
hamlet_compatible = true
icon = "modicon.tex"
icon_atlas = "modicon.xml"
binary = {
    { description = "Yes", data = true },
    { description = "No",  data = false }
}
configuration_options = {
    {
        name = "hud",
        label = "HUD",
        options = {
            { description = "Auto",      data = "auto" },
            { description = "None",      data = "normal" },
            { description = "Nightmare", data = "nightmare" },
            { description = "Lunar",     data = "lunar" },
            { description = "Celestial", data = "celestial" },
            { description = "Nautical",  data = "nautical" },
            { description = "Pig Ruins", data = "pig" },
            { description = "Roseate",   data = "rose" },
            { description = "Verdant",   data = "verdant" },
            -- {description="Forge",data="forge"},
            { description = "Victorian", data = "victorian" }
        },
        default = "auto"
    },
    {
        name = "fog_immune_neck",
        label = "Amulet Fog Immune",
        options = binary,
        default = true
    },
    {
        name = "fog_immune_back",
        label = "Backpack Fog Immune",
        options = binary,
        default = false
    },
    {
        name = "mannequin",
        label = "Mannequin",
        options = binary,
        default = true
    },
    {
        name = "wet",
        label = "Wetness Description",
        options = binary,
        default = true
    },
    {
        name = "hiddendanger",
        label = "Wagstaff Googles Hidden Danger",
        options = binary,
        default = true
    },
    {
        name = "fog",
        label = "Hamlet Fog",
        options = binary,
        default = true
    },
    {
        name = "snurtleshell",
        label = "Snurtle Shell",
        options = binary,
        default = true
    },
    {
        name = "greenamulet",
        label = "Constrction Amulet",
        options = binary,
        default = true
    },
    {
        name = "wilba",
        label = "Wilba Wereness Fur",
        options = binary,
        default = true
    },
    {
        name = "resurrectable",
        label = "Resurrectable Ways",
        options = binary,
        default = true
    },
    {
        name = "anim",
        label = "Anim",
        options = binary,
        default = true
    },
    {
        name = "invbar",
        label = "Inventory Bar",
        options = binary,
        default = true
    },
    {
        name = "back",
        label = "Backpack",
        options = binary,
        default = true
    },
    {
        name = "neck",
        label = "Amulet",
        options = binary,
        default = true
    },
    {
        name = "entergame",
        label = "Fix Backpack On Entering Game",
        options = binary,
        default = true
    }
}
if locale == "zh" then
    description = "添加一至两个槽：背包和护符"
    local c = configuration_options
    c[1] =
    {
        name = "hud",
        label = "HUD",
        options = {
            { description = "自动",       data = "auto" },
            { description = "原版",       data = "normal" },
            { description = "噩梦",       data = "nightmare" },
            { description = "月亮",       data = "lunar" },
            { description = "天体",       data = "celestial" },
            { description = "航海",       data = "nautical" },
            { description = "哈姆雷特", data = "pig" },
            { description = "玫瑰",       data = "rose" },
            { description = "青绿",       data = "verdant" },
            { description = "熔炉",       data = "forge" },
            { description = "灵魂",       data = "soul" },
            { description = "维多利亚", data = "victorian" }
        },
        default = "auto"
    }
    c[2].label = "护符免疫雾气"
    c[3].label = "背包免疫雾气"
    c[4].label = "假人"
    c[5].label = "湿度描述"
    c[6].label = "瓦格斯塔夫护目镜隐藏危险"
    c[7].label = "哈姆雷特浓雾"
    c[8].label = "蜗牛壳"
    c[9].label = "建造护符"
    c[10].label = "薇尔芭毛皮"
    c[11].label = "复活方式"
    c[12].label = "动画图层"
    c[13].label = "物品栏"
    c[14].label = "背包"
    c[15].label = "护符"
    c[16].label = "修复进入游戏时背包"
    binary[1].description = "是"
    binary[2].description = "否"
end
--[[
Add One/Two Slots: Backpack and Amulet
Currently the newest, most compatible, most complicated 5 slot mod in DS workshop. Sadly it doesn't promise to be compatible with mods.
[h1]Features[/h1]
[list]
[*]Construction Amulet support.
[*]HUD reskin mods support.
[*]Automatically guess things to be clothing or backpack.
[*]Life-Giving Amulet support.
[*]Vortex Cloak support. You can re-open your backpack by unequip-equiping it if you enabled Integrated Backpack mod.
[*]Hamlet fog will affect backpack but amulet.
[*]Wheeler support.
[*]Wilba transformation support.
[*]Skinned items support.
[*]Mannequin support.
[/list]

[h1]Known Issues[/h1]
[list]
[*]Snurtle Shell is both an armor and a clothing, but currently I can't handle it.
[*]Limited support for mod items. Support added from Extra Equip Slots Shipwrecked and Extra Equip Slots+3.
[*]slurtle brain
[*]spoil chest
[/list]

[h1]Impossible Things[/h1]
[list]
[*]glasses slot.
[/list]

[h1]Credit[/h1]
Extra Slots (Shipwrecked) [url]https://steamcommunity.com/sharedfiles/filedetails/?id=571751170[/url]
More equip slots [url]https://steamcommunity.com/sharedfiles/filedetails/?id=2324689937[/url]
Extra Equip Slots+3 [url]https://steamcommunity.com/sharedfiles/filedetails/?id=2798599672[/url]
[b]MX Slot[/b] [url]https://steamcommunity.com/sharedfiles/filedetails/?id=2890837039[/url]

[h1]Supported HUDs[/h1]
[list]
[*]    rose                     workshop-2250176974   /  2901677612
[*]    nightmare                workshop-1992293314   /  workshop-2712717471
[*]    victorian                workshop-1583765151   /  2901678005
[*]    clean                    workshop-2854270129
[*]    lunar                    workshop-2329943377
[*]    nautical                 workshop-2226345952   /  2901657164
[*]    pig  ruins               workshop-2284894693
[*]    verdant                  workshop-2238885511
[*]    celestial                workshop-2571443104
[*]    forge                    workshop-1824509831 / workshop-2901676969
[*]    soul                     workshop-2329943377
[/list]
]]
--[[
添加一至两个槽：背包和护符
目前是单机版创意工坊最新、最兼容、最复杂的5格mod。遗憾的是并不保证兼容mod。

[h1]特色[/h1]
[list]
[*]支持建造护符。
[*]支持HUD皮肤mod。
[*]自动猜测某物是衣服还是背包。
[*]支持重生护符。
[*]支持旋涡斗篷。你可以通过卸下-背上背包来重新打开背包，如果你启用了Integrated Backpack mod（融合背包）。
[*]哈姆雷特的浓雾会影响到背包，但不影响护符。
[*]由于单机版文件缺失图层，背包、护甲、护符显示三选一。
[*]支持Wheeler的格子。
[*]支持威尔芭变身。
[*]支持皮肤物品。
[*]支持Mannequin（联机假人）。
[/list]

[h1]已知问题[/h1]
[list]
[*]蜗牛护甲既是背部装备也是身体装备，但是我目前拿它没办法。
[*]有限支持mod物品。从Extra Slots (Shipwrecked) 与 4/5/6格装备栏（适配mod版）导入了一些。
[*]slurtle brain
[*]spoil chest
[/list]

[h1]不可能的事情[/h1]
[list]
[*]眼镜槽。
[/list]

[h1]致谢[/h1]
Extra Slots (Shipwrecked) [url]https://steamcommunity.com/sharedfiles/filedetails/?id=571751170[/url]
More equip slots [url]https://steamcommunity.com/sharedfiles/filedetails/?id=2324689937[/url]
4/5/6格装备栏（适配mod版） [url]https://steamcommunity.com/sharedfiles/filedetails/?id=2798599672[/url]
[b]MX Slot[/b] [url]https://steamcommunity.com/sharedfiles/filedetails/?id=2890837039[/url]

[h1]Supported HUDs 支持的HUD[/h1]
[list]
[*]    rose                 玫瑰                workshop-2250176974  /  2901677612
[*]    nightmare            噩梦                workshop-1992293314  /  workshop-2712717471
[*]    victorian            维多利亚（暴食）      workshop-1583765151  /  2901678005
[*]    clean                简洁                workshop-2854270129
[*]    lunar                月亮                workshop-2329943377
[*]    nautical             航海                workshop-2226345952  /  2901657164
[*]    pig                  哈姆雷特             workshop-2284894693
[*]    verdant              青绿                workshop-2238885511
[*]    celestial            天体                workshop-2571443104
[*]    forge              熔炉      workshop-1824509831 / workshop-2901676969
[*]    soul                灵魂     workshop-2329943377
[/list]
]]
