GLOBAL.setmetatable(env, {
    __index = function(t, k)
        return GLOBAL.rawget(GLOBAL, k)
    end
})
modimport("apis.lua")
HUDStyle = utils.onemod("scripts/utils/hud")
if not GLOBAL then
    require "scripts/apis"
    require("scripts/utils/switch")
    require("scripts/utils/witch")
    HUDStyle = require("scripts/utils/hud")
end
local Inv = require "components/inventory"
ExtraEquipSlots = utils.onemod("utils/slot")
local function AddExtraSlot()
    for k, v in pairs(ExtraEquipSlots) do
        if EQUIPSLOTS[k] == nil then
            EQUIPSLOTS[k] = v
        else
            ExtraEquipSlots[k] = nil
        end
    end
end
AddExtraSlot()
FOG_IMMUNE_SLOTS = utils.onemod("scripts/utils/fog_immune_slot")
local utilities = { "upvalue", "asset", "which", "switch", "sg", "anim" }
utils.mod("scripts/utils/", utilities)
local function HookInvBar(InvBar)
    for k, v in pairs(ExtraEquipSlots) do InvBar:AddEquipSlot(v, "assets/slots_" .. HUDStyle .. ".xml", v .. ".tex") end
end
utils.class("widgets/inventorybar", HookInvBar)

local function HookInventory()
    local GetEquippedItem = Inv.GetEquippedItem
    function Inv:GetEquippedItem(slot)
        if type(slot) == "table" then
            local ret = nil
            for i, v in ipairs(slot) do
                ret = GetEquippedItem(self, v)
                if ret then return ret end
            end
        end
        return GetEquippedItem(self, slot)
    end

    function Inv:GetAllEquippedItem(slots)
        if type(slots) ~= "table" then slots = { slots } end
        local ret = {}
        for k, v in pairs(slots) do if self.equipslots[v] then table.insert(ret, self.equipslots[v]) end end
        return ret
    end
end
HookInventory()
copy = copy or function(tbl)
    local ret = {}
    for k, v in pairs(tbl) do ret[k] = v end
    return ret
end
local tweaks = { "mannequin", "wet", "hiddendanger", "fog", "snurtleshell", "greenamulet", "wilba", "resurrectable",
    "anim", "invbar","entergame" }
for i, v in ipairs(tweaks) do
    if GetConfig(v) then
        utils.mod("scripts/tweaks/" .. v .. ".lua")
    end
end