local Inv = require "components/inventory"
local EQUIPLAYERS = {
    HEAD = "swap_hat",
    BODY = "swap_body",
    -- BACK = "swap_body_tall",--DST
    BACK = "swap_body",
    AMULET = "swap_body",
    NECK = "swap_body",
    HANDS = "swap_object",
    PACK = "swap_body"
}
local LAYEREQUIPS = {}
for k, v in pairs(EQUIPLAYERS) do
    if not LAYEREQUIPS[v] then LAYEREQUIPS[v] = {} end
    LAYEREQUIPS[v][k] = true
end
function Inv:RebuildSymbols(a, b, c)
    local slot = self.AnimState.slot
    -- print("slot=" .. slot)
    if not slot then return false end
    -- if it is a back item, put it in good place
    if a == EQUIPLAYERS.BODY and slot == EQUIPSLOTS.BACK then a = EQUIPLAYERS.BACK end
    local cur = self:GetCurrentSymbol(a) or {}
    cur[slot] = cur[slot] or {}
    local new = {}
    if not b then
        -- clear
        -- but there may be other clothes
        if LAYEREQUIPS[a] then
            for eslot, cloth in pairs(cur) do
                if eslot ~= slot then
                    if cloth[1] then
                        new = cloth
                        break -- unordered
                    end
                end
            end
        end
    else
        -- override
        new = { b, c }
    end

    -- print("current symbol:", a, b, c)
    -- dumptable(cur)
    -- print("new:", new[1], new[2])
    if not b then
        if not new[1] then
            -- clear
            self.AnimState:CacheClearOverrideSymbol(a)
        else
            -- don't clear, just change
            self.AnimState:CacheOverrideSymbol(a, unpack(new))
            self.AnimState.old:Show(a)
        end
        cur[slot] = {}
    else
        if new[1] == nil then
            -- clear
            self.AnimState:CacheClearOverrideSymbol(a)
            cur[slot] = {}
        elseif new[1] ~= cur[slot][1] or new[2] ~= cur[slot][2] then
            -- different
            -- override
            self.AnimState:CacheOverrideSymbol(a, unpack(new))
            cur[slot] = new
        end
    end
    return true
end

Inv = nil
local function HackInventory(self)
    if self.AnimState then return end
    self.currentsymbol = {}
    self.GetCurrentSymbol = function(self, build)
        local eq = build
        if not eq then return {} end
        local tbl = self.currentsymbol[eq]
        if not tbl then self.currentsymbol[eq] = {} end
        return self.currentsymbol[eq]
    end

    for k, v in pairs(EQUIPLAYERS) do self.currentsymbol[v] = {} end
    -- self.hascache = true
    self.AnimState = {
        old = self.inst.AnimState,
        slot = nil,
        inv = self,
        cache = {},
        ClearOverrideSymbol = function(_self, ...)
            return self:RebuildSymbols(...) or _self.old:ClearOverrideSymbol(...)
        end,
        OverrideSymbol = function(_self, ...)
            return self:RebuildSymbols(...) or _self.old:OverrideSymbol(...)
        end,
        OverrideItemSkinSymbol = function(_self, ...)
            return self:RebuildSymbols(...) or _self.old:OverrideItemSkinSymbol(...)
        end,
        Show = function(_self, ...)
            return _self.old:Show(...)
        end,
        Hide = function(_self, ...)
            return _self.old:Hide(...)
        end,
        CacheClearOverrideSymbol = function(_self, sym)
            _self.cache[sym] = false
        end,
        CacheOverrideSymbol = function(_self, sym, b, s)
            _self.cache[sym] = { sym, b, s }
        end,
        Do = function(_self)
            for k, v in pairs(_self.cache) do
                if v == false then
                    _self.old:ClearOverrideSymbol(k)
                elseif type(v) == "table" then
                    _self.old:OverrideSymbol(unpack(v))
                end
            end
            _self.cache = {}
        end
    }
    setmetatable(self.AnimState, {
        __index = function(_, k)
            return self.AnimState.old[k] and function(_self, ...)
                return self.AnimState.old[k](self.AnimState.old, ...)
            end
        end
    })
    local oldequip = self.Equip
    local oldunequip = self.Unequip
    local rawset = rawset
    local function Equip(_self, item, ...)
        local flag = self.inst.AnimState ~= self.AnimState
        if flag then
            rawset(self.AnimState, "old", self.inst.AnimState)
            rawset(self.inst, "AnimState", self.AnimState)
        end
        self.AnimState.slot = item and item.components.equippable and item.components.equippable.equipslot
        local ret = { oldequip(_self, item, ...) }
        if flag then
            rawset(self.inst, "AnimState", self.AnimState.old)
            self.AnimState:Do()
        end
        return unpack(ret)
    end

    local function Unequip(_self, slot, ...)
        local flag = self.inst.AnimState ~= self.AnimState
        if flag then
            rawset(self.AnimState, "old", self.inst.AnimState)
            rawset(self.inst, "AnimState", self.AnimState)
        end
        self.AnimState.slot = slot
        local ret = { oldunequip(_self, slot, ...) }
        if flag then
            rawset(self.inst, "AnimState", self.AnimState.old)
            self.AnimState:Do()
        end
        return unpack(ret)
    end

    self.Equip = Equip
    self.Unequip = Unequip
end
utils.player_raw(function(inst)
    local inv = inst.components.inventory
    if inv then HackInventory(inv) end
end)
