local InvBar = require("widgets/inventorybar")
local Rebuild = InvBar.Rebuild
local W = UpvalueGet(Rebuild, "W")
local SEP = UpvalueGet(Rebuild, "SEP")
local INTERSEP = UpvalueGet(Rebuild, "INTERSEP")
function InvBar:Rebuild(...)
    local scale = self.bg:GetScale()
    local ret = { Rebuild(self, ...) }
    local scale2 = self.bg:GetScale()
    if scale == scale2 then
        -- change it
        local num_slots = self.owner.components.inventory:GetNumSlots()
        local num_equip = #self.equipslotinfo
        local num_intersep = math.floor(num_slots / 5) + 1
        local total_w =
            (num_slots + num_equip) * (W) + (num_slots + num_equip - 2 - num_intersep) * (SEP) + INTERSEP
            * num_intersep
        local bg_scale = (1.15 * total_w) /
            (1480)     -- This is a bit ugly, the hardcoded 1480 is the standard width for a regular inventory total_w
        self.bg:SetScale(bg_scale, 1, 1)
        self.bgcover:SetScale(bg_scale, 1, 1)
    end
    return unpack(ret)
end

if InvBar.AddSpecialSlot then
    local u, v, n = UPVALUE.get(InvBar.AddSpecialSlot, "SPECIAL_SLOT_OFFSET")
    -- 140~=W*2+SEP=68*2+12=148
    if u and v and n then UPVALUE.set(u, n, v + 140) end
end
