utils.prefab("sewing_mannequin", function(inst)
    local function has_any_equipment(inst)
        for k, v in pairs(EQUIPSLOTS) do
            if inst.components.inventory:GetEquippedItem(v) ~= nil then return true end
        end
    end

    local CanSwap = UpvalueGet(inst.components.activatable.OnActivate, "CanSwap")
    local become_inactive = UpvalueGet(inst.components.activatable.OnActivate, "become_inactive")
    local function OnActivate(inst, doer)
        inst:DoTaskInTime(5 * FRAMES, become_inactive)
        local flag = true
        for k, v in pairs(EQUIPSLOTS) do
            if doer.components.inventory:GetEquippedItem(v)
                and doer.components.inventory:GetEquippedItem(v):HasTag("cantdrop") then
                flag = false
                break
            end
        end

        if flag and CanSwap(inst, doer) then
            flag = false
            for k, v in pairs(EQUIPSLOTS) do flag = inst.components.inventory:SwapEquipment(doer, v) or flag end

            if flag then
                inst.sg:GoToState("swap")
                inst.SoundEmitter:PlaySound("sewing_mannequin/sewing_mannequin/mannequin_swap")
                return true
            end
        else
            return false
        end
    end

    inst.components.activatable.OnActivate = OnActivate
    local u, v, n = UPVALUE.get(inst.components.activatable.OnActivate, "has_any_equipment")
    if u and v and n then UPVALUE.set(u, n, has_any_equipment) end
    local function should_accept_item(inst, item, doer)
        return item.components.equippable ~= nil and (item.components.equippable.equipslot), "GENERIC"
    end

    inst.components.trader:SetAcceptTest(should_accept_item)
end)
