utils.prefab("armorsnurtleshell", function(inst)
    local function OnBlocked(owner)
        owner.SoundEmitter:PlaySound("dontstarve/wilson/hit_armour")
    end

    local function ProtectionLevels(inst, data)
        local equippedArmor =
            inst.components.inventory and inst.components.inventory:GetAllEquippedItem(EQUIPSLOTS.BODY)
        for k, v in pairs(equippedArmor) do
            if v and v.prefab == "armorsnurtleshell" then
                equippedArmor = v
                break
            end
        end
        if data.statename == "shell_idle" or data.statename == "shell_hit" or data.statename == "shell_enter" then
            equippedArmor.components.armor:SetAbsorption(TUNING.FULL_ABSORPTION)
        else
            equippedArmor.components.armor:SetAbsorption(TUNING.ARMORSNURTLESHELL_ABSORPTION)
            equippedArmor.components.useableitem:StopUsingItem()
        end
    end

    local function newonequip(inst, owner)
        owner.AnimState:OverrideSymbol("swap_body", "armor_slurtleshell", "swap_body")
        inst:ListenForEvent("blocked", OnBlocked, owner)
        inst:ListenForEvent("newstate", ProtectionLevels, owner)
    end

    local function newonunequip(inst, owner)
        owner.AnimState:ClearOverrideSymbol("swap_body")
        inst:RemoveEventCallback("blocked", OnBlocked, owner)
        inst:RemoveEventCallback("newstate", ProtectionLevels, owner)
    end

    inst.components.equippable:SetOnUnequip(newonunequip)

    inst.components.equippable:SetOnEquip(newonequip)
end)