
function MakeSwitch(oldfn, redir)
    if not oldfn then return nil end
    if not redir then return oldfn end
    local newBODY = redir
    if type(redir) ~= "table" then
        newBODY = { EQUIPSLOTS[redir], EQUIPSLOTS.BODY }
    elseif not table.contains(newBODY, EQUIPSLOTS.BODY) then
        table.insert(newBODY, EQUIPSLOTS.BODY)
    end
    return function(...)
        local _BODY = EQUIPSLOTS.BODY
        EQUIPSLOTS.BODY = newBODY
        local ret = { oldfn(...) }
        EQUIPSLOTS.BODY = _BODY
        return unpack(ret)
    end
end
function MakeTargetSwitch(oldfn, targetfn)
    if not oldfn then return nil end
    return function(...)
        local targetslot = EQUIPSLOTS.BODY
        for k, v in pairs(EQUIPSLOTS) do if targetfn(v, ...) then targetslot = v end end
        local _BODY = EQUIPSLOTS.BODY
        EQUIPSLOTS.BODY = targetslot
        local ret = { oldfn(...) }
        EQUIPSLOTS.BODY = _BODY
        return unpack(ret)
    end
end

function MakeSubstitute(oldfn, redir)
    if not oldfn then return nil end
    local newBODY = redir
    if type(redir) ~= "table" then newBODY = { redir } end
    return function(...)
        local _BODY = EQUIPSLOTS.BODY
        EQUIPSLOTS.BODY = newBODY
        local ret = { oldfn(...) }
        EQUIPSLOTS.BODY = _BODY
        return unpack(ret)
    end
end