local function pfind(str, m)
    return string.find(str, m, 1, true)
end

local MODEQUIPSLOTS = MODEQUIPSLOTS or {}
rawset(_G, "MODEQUIPSLOTS", MODEQUIPSLOTS)
-- from 四五六格，Shipwrecked
MODEQUIPSLOTS.NECK = MODEQUIPSLOTS.NECK or {
    "broken_frosthammer",
    "musha_egg",
    "musha_egg1",
    "musha_egg2",
    "musha_egg3",
    "musha_egg8",
    "musha_eggs1",
    "musha_eggs2",
    "musha_eggs3",
    "brooch1",                -- 伊蕾娜
    "brooch2",                -- 伊蕾娜
    "brooch4",                -- 伊蕾娜
    "brooch5",                -- 伊蕾娜
    "brooch6",                -- 伊蕾娜
    "brooch7",                -- 伊蕾娜
    "brooch8",                -- 伊蕾娜
    "brooch9",                -- 伊蕾娜
    "moon_brooch",            -- 伊蕾娜
    "star_brooch",            -- 伊蕾娜
    "sorabowknot",            -- 小穹
    "terraprisma",            -- 光棱剑
    "kemomimi_new_xianglian", -- 小狐狸
    "kemomimi_bell",          -- 小狐狸
    "kemomimi_utr_xl",        -- 小狐狸
    "philosopherstone",       -- 托托莉
    "ov_bag2",                -- 和平鸽
    "oculet",
    "jinshudaikou",           -- 泰拉物品
    "zaishengshouhuan",       -- 泰拉物品
    "ruchongweijin"           -- 泰拉物品
}
MODEQUIPSLOTS.BACK = MODEQUIPSLOTS.BACK or {}
local rules = EQUIPSLOTSMAPPING or {
    {
        fn = function(inst)
            return inst.foleysound ~= nil and inst.foleysound == "dontstarve/movement/foley/jewlery"
        end,
        slot = "NECK"
    },
    {
        fn = function(inst)
            return pfind(inst.prefab, "amulet")
        end,
        slot = "NECK"
    },
    {
        fn = function(inst)
            return pfind(inst.prefab, "necklace")
        end,
        slot = "NECK"
    }, -- {prefab = "armorsnurtleshell", slot = "BACK"},--crash
    { prefab = "onemanband", slot = "BACK" },
    {
        fn = function(inst)
            return pfind(inst.prefab, "armor")
        end,
        slot = "BODY"
    },
    {
        fn = function(inst)
            return pfind(inst.prefab, "backpack")
        end,
        slot = "BACK"
    },
    {
        fn = function(inst)
            return table.contains(MODEQUIPSLOTS.NECK, inst.prefab)
        end,
        slot = "NECK"
    },
    {
        fn = function(inst)
            return table.contains(MODEQUIPSLOTS.BACK, inst.prefab)
        end,
        slot = "BACK"
    },
    {
        fn = function(inst)
            return pfind(inst.prefab, "skirt")
        end,
        slot = "BODY"
    },
    {
        fn = function(inst)
            return string.find(inst.prefab, "sack$")
        end,
        slot = "BACK"
    },
    {
        fn = function(inst)
            return string.find(inst.prefab, "pack$")
        end,
        slot = "BACK"
    }, -- vortex cloak and others are armor, but this have exception.
    {
        fn = function(inst)
            return inst.components.container ~= nil and inst.components.armor == nil
        end,
        slot = "BACK"
    }
}
rawset(_G, "EQUIPSLOTSMAPPING", rules)
-- note that the assumption is that one prefab is projected to one slot
local cache = {}
local function GetTargetSlot(inst)
    if cache[inst.prefab] then return cache[inst.prefab] end
    local eslot = nil
    for k, v in ipairs(rules) do
        if v.fn and v.fn(inst) then
            eslot = EQUIPSLOTS[v.slot]
        elseif v.prefab and inst.prefab == v.prefab then
            eslot = EQUIPSLOTS[v.slot]
        elseif v.tags
            and (type(v.tags) == "table" and (inst.HasOneOfTag and inst:HasOneOfTag(v.tags)) or inst:HasTag(v.tags)) then
            eslot = EQUIPSLOTS[v.slot]
        end
        if eslot then
            break
        end
    end
    eslot = eslot or inst.components.equippable.equipslot or EQUIPSLOTS.BODY
    cache[inst.prefab] = eslot
    return eslot
end
utils.prefabany(function(inst)
    if inst.components.equippable ~= nil and inst.components.equippable.equipslot == EQUIPSLOTS.BODY then
        inst.components.equippable.equipslot = GetTargetSlot(inst)
    end
end)
